#include "image_point_set.hpp"

#include "color.hpp"

std::vector<vec2> extract_point_set_from_image(const image& im)
{
    std::vector<vec2> v;

    const unsigned int Nx=im.Nx;
    const unsigned int Ny=im.Ny;
    for(unsigned int kx=0;kx<Nx;++kx)
    {
        for(unsigned int ky=0;ky<Ny;++ky)
        {
            const color& c=im(kx,ky);
            if(c.r<50 && c.g<50 && c.b<50)
                v.push_back(vec2(kx,ky));
        }
    }

    return v;
}

void add_point_set_to_image(image& im,const std::vector<vec2>& v,const color& c)
{
    unsigned int Nx=im.Nx;
    unsigned int Ny=im.Ny;

    const unsigned int N=v.size();
    for(unsigned int k=0;k<N;++k)
    {
        const vec2& p=v[k];
        int x=p.x;
        int y=p.y;

        if(x>=0 && x<Nx && y>=0 && y<Ny)
            im(x,y)=c;
    }
}
