#include <iostream>

#include "../../../eigen/include/eigen3/Eigen/Dense"
#include "../../../eigen/include/eigen3/Eigen/Eigenvalues"

#include "image.hpp"
#include "image_ppm.hpp"
#include "image_point_set.hpp"
#include "vec2.hpp"

#include <vector>

//projection mls version matrice pleine
vec2 projection_mls(const vec2& p0,const std::vector<vec2>& v)
{
    //TO DO
    //
    // Projection de p0 sur la droite obtenue par MLS
    //
    // 1) Calcule de la droite D par MLS
    // 2) p = Projection orthogonale de p0 sur D
    //
    // retourner p.

    return vec2(0,0);

}

int main()
{
    //fichier d'entree
    const std::string filename="input.ppm";

    //chargement d'une image
    image im=load_image(filename);

    //extraction des points noirs sous forme de coordonnees
    std::vector<vec2> v=extract_point_set_from_image(im);

    const unsigned int N=v.size();

    //Normalization of vertex coordinate (between 0 and 1)
    const float max_size_image=std::max(im.Nx,im.Ny);
    for(unsigned int k=0;k<N;++k)
        v[k]/=max_size_image;


    //projection de chaque point
    std::vector<vec2> projected_vertex(N);
    for(unsigned int k=0;k<N;++k)
    {
        //appel a la fonction de projection par MLS
        vec2 p=projection_mls(v[k],v);
        p*=max_size_image;
        projected_vertex[k]=p;

    }

    //ajout d'un ensemble de point a une image
    add_point_set_to_image(im,projected_vertex,color(255,0,0));

    //sauvegarde de l'image resultante
    save_image("output.ppm",im);


    return 0;
}
