#include "vec2.hpp"

#include <sstream>
#include <cmath>

vec2::vec2()
    :x(0.0f),y(0.0f)
{

}

vec2::vec2(float x_arg,float y_arg)
    :x(x_arg),y(y_arg)
{

}

std::string to_string(const vec2& v,const std::string& separator)
{
    std::stringstream stream;
    stream<<v.x<<separator<<v.y;

    return stream.str();
}

float distance(const vec2& v0,const vec2& v1)
{
    const float dx=v1.x-v0.x;
    const float dy=v1.y-v0.y;
    return std::sqrt(dx*dx+dy*dy);
}

vec2& operator/=(vec2& v,const float s)
{
    v.x/=s;
    v.y/=s;
    return v;
}
vec2& operator*=(vec2& v,const float s)
{
    v.x*=s;
    v.y*=s;
    return v;
}


