#include "point_set.hpp"

#include <iostream>
#include <cmath>

#include "../../../eigen/include/eigen3/Eigen/Eigenvalues"
#include "../../../eigen/include/eigen3/Eigen/Dense"




void point_set::add_vertex(int x,int y)
{
    data_src.push_back(vec2(x,y));
}


void point_set::draw_center(QPainter& painter) const
{
     painter.drawPoint(center.x,center.y);
}

void point_set::draw_inertia_0(QPainter& painter) const
{
    float L=1.0;
    painter.drawLine(center.x-L*eigen_0.x,center.y-L*eigen_0.y,
                     center.x+L*eigen_0.x,center.y+L*eigen_0.y);

}
void point_set::draw_inertia_1(QPainter& painter) const
{
    float L=1.0;
    painter.drawLine(center.x-L*eigen_1.x,center.y-L*eigen_1.y,
                     center.x+L*eigen_1.x,center.y+L*eigen_1.y);
}


void point_set::draw_src_vertex(QPainter& painter) const
{
    std::list<vec2>::const_iterator it     = data_src.begin();
    std::list<vec2>::const_iterator it_end = data_src.end();

    for(;it!=it_end;++it)
    {
        const vec2& p=*it;
        painter.drawPoint(p.x,p.y);
    }
}


void point_set::draw_projected_mls(QPainter& painter) const
{
    float L=40.0;
    painter.drawPoint(projected_vertex.x,projected_vertex.y);
    painter.drawLine(projected_vertex.x-L*direction_line.x,projected_vertex.y-L*direction_line.y,
                     projected_vertex.x+L*direction_line.x,projected_vertex.y+L*direction_line.y);
}



void point_set::update_inertia()
{
    compute_center();
    compute_inertia();
}

void point_set::compute_center()
{
    //TO DO
    // A completer:
    //center=??

}

void point_set::compute_inertia()
{

    //TO DO
    // A completer:
    //eigen_0=??
    //eigen_1=??
}


void point_set::compute_line_approximation(int x,int y)
{
    //TO DO
    // A completer:
    //projected_vertex=??
    //direction_line=??

}

