
#pragma once

#ifndef POINT_SET_HPP
#define POINT_SET_HPP

#include "vec2.hpp"

#include <list>
#include <queue>

#include <QPainter>



class point_set
{
public:


    void add_vertex(int x,int y);

    void update_inertia();

    void draw_src_vertex(QPainter& painter) const;
    void draw_center(QPainter& painter) const;
    void draw_inertia_0(QPainter& painter) const;
    void draw_inertia_1(QPainter& painter) const;
    void draw_projected_mls(QPainter& painter) const;


    void affiche_filtered(QPainter& painter) const;



    void compute_line_approximation(int x,int y);







private:
    std::list<vec2> data_src;

    vec2 center;
    vec2 eigen_0,eigen_1;
    vec2 projected_vertex;
    vec2 direction_line;


    void compute_center();
    void compute_inertia();


};

#endif
