#pragma once

#ifndef RENDER_AREA_HPP
#define RENDER_AREA_HPP

#include "point_set.hpp"

#include <QWidget>
#include <QPixmap>
#include <QBrush>
#include <QPen>
#include <QTime>



class render_area : public QWidget
{
    Q_OBJECT
public:
    render_area(QWidget *parent = 0);
    ~render_area();




    void update_bool(bool is_drawing_mode_arg,
                     bool is_click_mode_arg,
                     bool is_draw_inertia_arg,
                     bool is_draw_tangent_arg);



protected:
     void paintEvent(QPaintEvent *event);

     void mouseMoveEvent(QMouseEvent *event);
     void mousePressEvent(QMouseEvent *event);

private:

     QPixmap pixmap;
     point_set data;
     QTime timer;

     bool is_drawing_mode;
     bool is_click_mode;
     bool is_draw_inertia;
     bool is_draw_tangent;

};

#endif
