#include "vec2.hpp"

#include <sstream>
#include <cmath>

vec2::vec2()
    :x(0.0f),y(0.0f)
{

}

vec2::vec2(float x_arg,float y_arg)
    :x(x_arg),y(y_arg)
{

}

std::ostream& operator<<(std::ostream& stream,const vec2& v)
{
    stream<<v.x<<" "<<v.y;
    return stream;
}

std::string to_string(const vec2& v,const std::string& separator)
{
    std::stringstream stream;
    stream<<v.x<<separator<<v.y;

    return stream.str();
}

float distance(const vec2& v0,const vec2& v1)
{
    float dx=v1.x-v0.x;
    float dy=v1.y-v0.y;
    return std::sqrt(dx*dx+dy*dy);
}

vec2& operator +=(vec2& v0,const vec2& v1)
{
    v0.x+=v1.x;
    v0.y+=v1.y;
    return v0;
}

vec2& operator /=(vec2& v0,float s)
{
    v0.x/=s;
    v0.y/=s;
    return v0;
}
