#include "window.hpp"
#include "render_area.hpp"

#include <iostream>

#include <ui_mainwindow.h>
#include <Qt/QtOpenGL>

window::window(QWidget *parent)
    :QMainWindow(parent),ui(new Ui::MainWindow)
{
    std::cout<<"Generation de la fenetre"<<std::endl;

    ui->setupUi(this);

    //creation fenetre affichage
    render=new render_area;
    ui->layout_scene->addWidget(render);

    //connection signaux
    connect(ui->quitter,SIGNAL(clicked()),this,SLOT(action_quitter()));
    connect(ui->draw_inertia,SIGNAL(clicked()),this,SLOT(update_button()));
    connect(ui->draw_tangent,SIGNAL(clicked()),this,SLOT(update_button()));
    connect(ui->drawing_mode,SIGNAL(clicked()),this,SLOT(update_button()));
    connect(ui->click_mode,SIGNAL(clicked()),this,SLOT(update_button()));
}


window::~window()
{
    std::cout<<"Terminaison fenetre"<<std::endl;
    if(ui!=NULL)
    {
        delete ui;
        ui=NULL;
    }
}

void window::action_quitter()
{
    close();
}

void window::update_button() const
{
    render->update_bool(ui->drawing_mode->isChecked(),
                        ui->click_mode->isChecked(),
                        ui->draw_inertia->isChecked(),
                        ui->draw_tangent->isChecked());

}
